SystemOrganization addCategory: #GhostProxiesTests!

Object subclass: #GHUser
	instanceVariableNames: 'username'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxiesTests'!

!GHUser class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/9/2012 11:06'!
named: aName
	^ self new username: aName! !

!GHUser methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 2/9/2012 11:07'!
username
	^ username! !

!GHUser methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 2/9/2012 11:07'!
username: anObject
	username := anObject! !

TestCase subclass: #GHSimpleForwarderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxiesTests'!

!GHSimpleForwarderTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/9/2012 11:58'!
setUp
	GHProxyTrap initialize.   
	FileDirectory default deleteFileNamed:  'GhostLog.txt'.
	GHGhostLogger changeToFileLogger.
	! !

!GHSimpleForwarderTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/9/2012 11:55'!
testSimpleForwardingForMethodUsingBecome
       | aProxy aUser method |
       aUser := GHUser named: 'Kurt'.
       method := GHUser methodDict at: #username.
       [aProxy := GHProxy createProxyAndReplace: method handler: GHSimpleForwarderProxyHandler new. 
       self assert: aProxy getSource equals: 'username ^ username'. 
       self assert: aUser username equals: 'Kurt'.
	 ] ensure: [ aProxy name ]! !

!GHSimpleForwarderTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/9/2012 11:00'!
testSimpleForwardingForRegularObject
	| proxy |
	proxy := GHProxy createProxyFor: (Point x: 3 y: 4) handler: GHSimpleForwarderProxyHandler new. 
	self assert: proxy x equals: 3. 
	self assert: proxy y equals: 4.! !

!GHSimpleForwarderTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/9/2012 11:00'!
testSimpleForwardingForRegularObject2
	| proxy |
	proxy := GHProxy createProxyFor: (GHUser named: 'mariano') handler: GHSimpleForwarderProxyHandler new. 
	self assert: proxy username = 'mariano'.! !

!GHSimpleForwarderTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/9/2012 11:52'!
testSimpleForwardingForRegularObjectWithBecome
	| proxy |
	proxy := GHProxy createProxyAndReplace: (Point x: 3 y: 4) handler: GHSimpleForwarderProxyHandler new. 
	self assert: proxy x equals: 3. 
	self assert: proxy y equals: 4.! !
